App GeoFeature

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page App GeoFeature and the translation is 58% complete.
Other languages:
English • ‎français • ‎italiano

Introduzione

Feature.svg

Un oggetto App GeoFeature, o formalmente un App::GeoFeature, è la classe base della maggior parte degli oggetti che visualizzano elementi geometrici nella vista 3D perché include la proprietà DatiPosizionamento.

FreeCAD core objects.svg

Diagramma semplificato delle relazioni tra gli oggetti principali del programma. La classe App::GeoFeature è essenzialmente la classe base di tutti gli oggetti nel software che mostrano una geometria nella vista 3D.


Utilizzo

App GeoFeature è un oggetto interno, quindi non può essere creato dall'interfaccia grafica. In genere non è pensato per essere utilizzato direttamente, ma può essere suddiviso in sottoclassi per ottenere un oggetto vuoto che ha solo la proprietà di base DataPlacement per definire la sua posizione nella vista 3D .

Alcuni degli oggetti derivati più importanti sono i seguenti:

  • La classe Part Feature, il genitore della maggior parte degli oggetti con forme topologiche 2D e 3D.
  • La classe Mesh Feature, il genitore della maggior parte degli oggetti realizzati da mesh, non solidi.
  • La classe Fem FemMeshObject, il genitore delle mesh di elementi finiti create con l'ambiente FEM.
  • La classe Path Feature, il genitore dei percorsi creati con l'ambiente Path per l'uso nella lavorazione CNC.
  • La classe App Part, che definisce Std Parts che può essere utilizzato come contenitore di corpi per eseguire assiemi.

Quando si crea questo oggetto in Python, invece di sottoclassare App::GeoFeature, è necessario sottoclassare App::GeometryPython perché quest'ultimo include di default un provider di visualizzazione e gli attributi Proxy per l'oggetto stesso e il relativo provider di visualizzazione. Vedere Script.

Proprietà

Un oggetto App GeoFeature (classe App::GeoFeature) è derivato dall'oggetto base App DocumentObject (classe App::DocumentObject), pertanto condivide tutte le proprietà di quest'ultimo.

Oltre alle proprietà descritte in App DocumentObject, GeoFeature ha la proprietà DataPlacement, che controlla la sua posizione nella vista 3D.

Vedere Proprietà per tutti i tipi di proprietà che possono avere gli oggetti con script.

Queste sono le proprietà disponibili nell'editor delle proprietà. Le proprietà nascoste possono essere mostrate usando il comando Mostra tutto nel menu contestuale dell'editor delle proprietà.

Dati

Base

  • DataPlacement (Placement): the position of the object in the 3D view. The placement is defined by a Base point (vector), and a Rotation (axis and angle). See Placement.
    • DataAngle: the angle of rotation around the DataAxis. By default, it is (zero degrees).
    • DataAxis: the unit vector that defines the axis of rotation for the placement. Each component is a floating point value between 0 and 1. If any value is above 1, the vector is normalized so that the magnitude of the vector is 1. By default, it is the positive Z axis, (0, 0, 1).
    • DataPosition: a vector with the 3D coordinates of the base point. By default, it is the origin (0, 0, 0).
  • DataLabel (String): the user editable name of this object, it is an arbitrary UTF8 string.

Hidden properties Data

  • Data (hidden)Proxy (PythonObject): a custom class associated with this object. This only exists for the Python version. See Scripting.
  • Data (hidden)Label2 (String): a longer, user editable description of this object, it is an arbitrary UTF8 string that may include newlines. By default, it is an empty string "".
  • Data (hidden)Expression Engine (ExpressionEngine): a list of expressions. By default, it is empty [].
  • Data (hidden)Visibility (Bool): whether to display the object or not.

Vista

Base

  • View (hidden)Proxy (PythonObject): a custom view provider class associated with this object. This only exists for the Python version. See Scripting.

Display Options

  • ViewBounding Box (Bool): if it is true, the object will show the bounding box in the 3D view.
  • ViewDisplay Mode (Enumeration): see the information in App FeaturePython.
  • ViewShow In Tree (Bool): see the information in App FeaturePython.
  • ViewVisibility (Bool): see the information in App FeaturePython.

Object Style

  • ViewShape Color (Color): a tuple of three floating point RGB values (r,g,b) to define the color of the faces in the 3D view; by default it is (0.8, 0.8, 0.8), which is displayed as [204, 204, 204] on base 255, a light gray .
  • View (hidden)Shape Material (Material): an App Material associated with this object. By default it is empty.
  • ViewTransparency (Percent): an integer from 0 to 100 that determines the level of transparency of the faces in the 3D view. A value of 100 indicates completely invisible faces; the faces are invisible but they can still be picked as long as ViewSelectable is true.

Selection

  • ViewOn Top When Selected (Enumeration): see the information in App FeaturePython.
  • ViewSelectable (Bool): if it is true, the object can be picked with the pointer in the 3D view. Otherwise, the object cannot be selected until this option is set to true.
  • ViewSelection Style (Enumeration): see the information in App FeaturePython.

Script

See also: FreeCAD Scripting Basics, and scripted objects.

See Part Feature for the general information on adding objects to the program

A GeoFeature is created with the addObject() method of the document. If you would like to create an object with a 2D or 3D topological shape, it may be better to create one of the sub-classes specialized for handling shapes, for example, Part Feature or Part Part2DObject.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::GeoFeature", "Name")
obj.Label = "Custom label"

This basic App::GeoFeature doesn't have a default view provider, so no icon will be displayed on the tree view, and no View properties will be available.

Therefore, for Python subclassing, you should create the App::GeometryPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::GeometryPython", "Name")
obj.Label = "Custom label"

For example, the Arch BuildingPart element of the Arch Workbench is an App::GeometryPython object with a custom icon.